//Client.h

#include "Utilitaires.h"

class Client
{
 private:
  struct Tmsgperso{long etiquette; char contenu;} msgperso; //structure pour la file de messages
  int idfile; //descripteur de la file
  int tube; //descripteur de tube nomm
  bool ok; //pour forcer l'arrt
  bool automatique; //pour le mode automatique ou pas
 protected:
  void create(bool automatik); //suite du constructeur
  void suicide(); //autodestruction du processus de l'instance Client
  void consommer(int duree); //consomme une dure en secondes et fait un choix
  void creerFils(int param); //cre un processus fils Client et le prsente  GrandElecteur
                             //param est le choix (candidat ou dsistement) du processus pre
  void transmettre(int codeMessage); //transmet au GrandElecteur les choix par le tube nomm
  void ecouterFile(); //reoit les signaux du GrandElecteur et agit en consquence
  void affiche(string texte); //affiche le texte sur la sortie standard
  char lireChoix(short maxi); //permet  l'utilisateur d'entrer le choix que doit faire le Client
 public:
  Client();
  Client(bool automatik);
  ~Client();
  void run(); //pour dmarrer l'activit du Client
  void stop(); //pour arrter l'activit du Client
};
